using System;
using System.Linq;

/// @author Antti-Jussi Lakanen, Vesa Lappalainen
/// @version 2025
/// 
/// <summary>
/// Demo 6, tehtävät 5-6.
/// Tehtävässä lasketaan taulukon miidi ja
/// tehdään tarvittavat apufunktiot.
/// </summary>
public class B2_3_ParasHintaArvio
{
    /// <summary>
    /// Kutsut
    /// </summary>
    public static void Main()
    {
        int[] luvut1 = { 100, 110, 90, 105, 115 }; 
        double hinta1 = ParasHintaArvio(luvut1); //

        int[] luvut2 = { 1 };
        double hinta2 = ParasHintaArvio(luvut2); // 1

        int[] luvut3 =  { 3, 3 };
        double hinta3 = ParasHintaArvio(luvut3); // 3

        int[] luvut4 = { };
        double hinta4 = ParasHintaArvio(luvut4); // 0

        Console.WriteLine(hinta1);
        Console.WriteLine(hinta2);
        Console.WriteLine(hinta3);
        Console.WriteLine(hinta4);
    }

    /// <summary>
    /// Funktio palauttaa annetun double-taulukon 
    /// lukujen keskiarvoa lähinnä oleva joukon 
    /// alkion. Jos joukon alkioista useita on 
    /// yhtä lähellä keskiarvoa, valitaan ''miidiksi''
    /// se alkio, joka on ensimmäisenä esiintynyt 
    /// taulukossa.
    /// </summary>
    /// <param name="luvut">Tutkittava taulukko.</param>
    /// <returns>Alkio, joka on lähimpänä
    /// taulukon keskiarvoa.</returns>
    /// <example>
    /// <pre name="test">
    /// ParasHintaArvio(new int[] {1, 2, 3, 2, 5}) === 3;
    /// ParasHintaArvio(new int[] {1, 1, 1}) === 1;
    /// ParasHintaArvio(new int[] {1, 2, 3}) === 2;
    /// ParasHintaArvio(new int[] {}) === 0;
    /// ParasHintaArvio(new int[] {1}) === 1;
    /// ParasHintaArvio(new int[] {1, 3}) === 1;
    /// ParasHintaArvio(new int[] {3, 1}) === 3;
    /// ParasHintaArvio(new int[] {3, 1, 3, 1}) === 3;
    /// </pre>
    /// </example>
    public static double ParasHintaArvio(int[] luvut)
    {
        if (luvut.Length == 0) return 0.0;
        double keskiarvo = Keskiarvo(luvut);
        double lahin = EtsiLahin(luvut, keskiarvo);
        return lahin;
    }


    /// <summary>
    /// Anna taulukosta (luvut) se joka on annettua lukua (etsittava) lähimpänä. 
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <param name="etsittava">Luku</param>
    /// <returns></returns>
    public static double EtsiLahin(int[] luvut, double etsittava)
    {
        // lahin-muuttuja sisältää "ehdokkaan"
        int lahin = luvut[0];
        // lahinEtaisyys tarkoittaa "pienintä poikkeamaa" keskiarvosta
        double lahinEtaisyys = Etaisyys(luvut[0], etsittava); // tämän muuttujan voi halutessaan jättää pois

        for (int i = 1; i < luvut.Length; i++)
        {
            // Vaihe 1: Tämän hetkisen alkion etäisyys etsittävästä luvusta (keskiarvosta)
            double etaisyys = Etaisyys(luvut[i], etsittava); 
            
            // Vaihe 2: Tutkitaan onko vaiheessa 1 löydetty etäisyys pienempi kuin pienin löydetty etäisyys
            if (etaisyys < lahinEtaisyys) 
            // if (etaisyys < Etaisyys(lahin, etsittava)) // vaihe 2, jos lahinEtaisyys-muuttuja on jätetty pois.
            {
                // Vaihe 3: Mikäli on, päivitetään uudeksi
                // lahin-ehdokkaaksi paikassa i oleva alkio JA lahinEtaisyys
                lahin = luvut[i]; // vaihe 3 
                lahinEtaisyys = etaisyys;  // vaihe 3 
            }
        }
        return lahin;
    }

    /// <summary>
    /// Funktio palauttaa kahden annetun liukuluvun 
    /// välisen etäisyyden.
    /// </summary>
    /// <param name="a">Luku a.</param>
    /// <param name="b">Luku b.</param>
    /// <returns>Lukujen välinen etäisyys.</returns>
    /// <example>
    /// <pre name="test">
    /// Etaisyys(0, 0) ~~~ 0;
    /// Etaisyys(-1, 1) ~~~ 2;
    /// Etaisyys(-5.1, 0) ~~~ 5.1;
    /// Etaisyys(-5.1, -4.9) ~~~ 0.2;
    /// </pre>
    /// </example>
    public static double Etaisyys(double a, double b)
    {
        double etaisyys = Itseisarvo(a - b);
        return etaisyys;
    }

    /// <summary>
    /// Aliohjelma palauttaa annetun
    /// kokonaislukutaulukon alkioiden
    /// summan.
    /// </summary>
    /// <param name="taulukko">Kokonaislukutaulukko</param>
    /// <returns>Summa</returns>
    public static int Summa(int[] taulukko)
    {
        int summa = 0;
        for (int i = 0; i < taulukko.Length; i++) summa += taulukko[i];
        return summa;
    }

    /// <summary>
    /// Aliohjelma palauttaa double-taulukon
    /// alkioiden keskiarvon.
    /// </summary>
    /// <param name="taulukko">Tutkittava taulukko.</param>
    /// <returns>Alkioiden keskiarvo.</returns>
    /// <example>
    /// <pre name="test">
    /// Keskiarvo(new int[]{1, 2, 3, 2, 5}) ~~~ 2.6;
    /// Keskiarvo(new int[]{}) ~~~ 0;
    /// Keskiarvo(new int[]{1, 1, 1}) ~~~ 1;
    /// Keskiarvo(new int[]{0}) ~~~ 0;
    /// Keskiarvo(new int[]{-1, 1}) ~~~ 0;
    /// Keskiarvo(new int[]{-2, -1}) ~~~ -1.5;
    /// </pre>
    /// </example>
    public static double Keskiarvo(int[] taulukko)
    {
        if (taulukko.Length < 1) return 0;
        double summa = Summa(taulukko);
        return summa / taulukko.Length;
    }


    /// <summary>
    /// Funktio palauttaa annetun liukuluvun itseisarvon.
    /// </summary>
    /// <param name="luku">Luku.</param>
    /// <returns>Luvun itseisarvo.</returns>
    /// <example>
    /// <pre name="test">
    /// Itseisarvo(0) ~~~ 0;
    /// Itseisarvo(-1.1) ~~~ 1.1;
    /// Itseisarvo(1.1) ~~~ 1.1;
    /// Itseisarvo(5-10) ~~~ 5;
    /// </pre>
    /// </example>
    public static double Itseisarvo(double luku)
    {
        if (luku < 0) return luku * (-1);
        else return luku;
    }
    
    /// <summary>
    /// Nohevan opiskelijan Linq-versio. 
    /// </summary>
    /// <param name="luvut"></param>
    /// <returns></returns>
    public static int ParasHintaArvio2(int[] luvut)
    {
        var keskiarvo = luvut.Average();
        return luvut.OrderBy(hinta => Math.Abs(hinta - keskiarvo))
            .ThenByDescending(hinta => hinta)
            .First();
    }
}