using System;

/// @author anlakane
/// @version 2025
/// 
/// <summary>
/// Demo 6, tehtävät 2 ja 3.
/// Itseisarvo ja etäisyys
/// </summary>
public class T2_3_ItseisarvoJaEtaisyys
{
    /// <summary>
    /// Kutsut ja tulostukset.
    /// </summary>
    public static void Main()
    {
        double luku = -6.5;
        double lukuEiNegatiivisena = Itseisarvo(luku);
        Console.WriteLine(lukuEiNegatiivisena);

        double a, b;
        a = 3.2; // Nämä ovat esimerkkilukuja.
        b = 8.5; // Luonnollisesti nämä voisivat olla muitakin lukuja. 
        double etaisyys = Etaisyys(a, b);
        Console.WriteLine(etaisyys);
    }

    /// <summary>
    /// Kahden luvun välinen etäisyys
    /// </summary>
    /// <param name="a">Luku 1</param>
    /// <param name="b">luku 2</param>
    /// <returns>Etäisyys</returns>
    /// <example>
    /// <pre name="test">
    /// Etaisyys(5, 3) === 2;
    /// Etaisyys(3, 5) === 2;
    /// Etaisyys(-3, -5) === 2;
    /// Etaisyys(0, 0) === 0;
    /// Etaisyys(-1, 1) === 2;
    /// Etaisyys(-1, 2) === 3;
    /// Etaisyys(-1.1, 2) ~~~ 3.1;
    /// </pre>
    /// </example>
    public static double Etaisyys(double a, double b)
    {
        double erotus = a - b;
        double itseisarvo = Itseisarvo(erotus);
        return itseisarvo;

        // TAI:
        // return Itseisarvo(a - b);
        // TAI: 
        // return Itseisarvo(erotus);
    }

    /// <summary>
    /// Luvun itseisarvo
    /// </summary>
    /// <param name="luku">Luku</param>
    /// <returns>Itseisarvo</returns>
    /// <example>
    /// <pre name="test">
    /// Itseisarvo(3) === 3;
    /// Itseisarvo(-3) === 3;
    /// Itseisarvo(-3.1) ~~~ 3.1;
    /// Itseisarvo(-1) === 1;
    /// Itseisarvo(0) === 0;
    /// </pre>
    /// </example>
    public static double Itseisarvo(double luku)
    {
        if (luku < 0)
        {
            return luku * (-1);
        }

        else return luku;
    }
}